@echo off
rem ==========================================
rem Housekeeping V22.07.24.1015
rem ==========================================

rem Entfernen von Dateien und Ordner aelter als zb. 50 Tage....
rem wir achten hier auf das attribut "erstellt"
rem sobald eine datei/ordner "erstellt " aelter als 50 Tage ist wird sie entfernt
rem bei der sicherung via FTP wird das "erstellt" Attribut auf den Zeitpunkt
rem der uebertragung gesetzt


rem ============VORRAUSSETZUNGEN==============================================
rem 1 - Script im Ordner c:\batch
rem 2 - wir brauchen die datei delage32 ebenso in c:\batch
rem 3 - es muss der Unterordner c:\batch\LOG existieren
rem 4 - Pfad und Tage beim Befehl delage32 anpassen
rem 5 - housekeeping.bat via Aufgabenplaner 1x am Tag starten
rem ========================================================================== 

set LOGDIR=C:\BATCH\LOG\

rem -----------------------------------------
rem Phase 1: Zeitstempel bauen fuer Logdatei
rem das brauchen wir, weil windows mit bordmitteln keinen brauchbaren datum-zeitstempel hat
rem Quelle:https://stackoverflow.com/questions/11037831/filename-timestamp-in-windows-cmd-batch-script-getting-truncated
rem Zeitstempel= 2016-04-04_14-45-25
rem -----------------------------------------
@echo off
SETLOCAL ENABLEDELAYEDEXPANSION
:: put your desired field delimiter here.
:: for example, setting DELIMITER to a hyphen will separate fields like so:
:: yyyy-MM-dd_hh-mm-ss
::
:: setting DELIMITER to nothing will output like so:
:: yyyyMMdd_hhmmss
::
SET DELIMITER=-

SET DATESTRING=%date:~-4,4%%DELIMITER%%date:~-7,2%%DELIMITER%%date:~-10,2%
SET TIMESTRING=%TIME%
::TRIM OFF the LAST 3 characters of TIMESTRING, which is the decimal point and hundredths of a second
set TIMESTRING=%TIMESTRING:~0,-3%

:: Replace colons from TIMESTRING with DELIMITER
SET TIMESTRING=%TIMESTRING::=!DELIMITER!%

:: if there is a preceeding space substitute with a zero
echo %DATESTRING%_%TIMESTRING: =0%
rem -------------- Zeitstempel ende -----------------------

rem -------------------------------------------------------
rem Zeitstempel in die Variable Zeitstempel bringen
rem -------------------------------------------------------
set Zeitstempel=%DATESTRING%_%TIMESTRING: =0%
rem.
rem Kontrollausgabe wie der Zeitstempel dann aussieht
echo Zeitstempel %Zeitstempel%
timeout 10


rem -------------------------------------------------------
rem hier werden dann die dateien entfernt
rem -------------------------------------------------------

cd c:\batch
IF not exist %LOGDIR% (mkdir %LOGDIR%) 

rem wichtig ist der parameter /created, das ist das datum der ftp bertragung der dateien
rem also alle dateien und ordner die lter als 50 tage sind
rem der parameter /recurse ist wichtig fuer die unterordner

delage32 "d:\tmp\*.*" 50 /recurse /created > c:\batch\log\%Zeitstempel%.log
timeout 10